<template>
    <block type="intro-slider" class="glide">
        <div class="intro-slider__track glide__track" data-glide-el="track">
            <div class="intro-slider__slides glide__slides">
                <block-intro v-for="(slide, index) in intro_.slides" :key="index" :intro="slide" class="glide__slide">
                    <template slot="buttons">
                        <btn :color="slide.intro_button.color" :dots="slide.intro_button.dots" v-if="slide.intro_button && slide.intro_button.button && slide.intro_button.button.url" :href="slide.intro_button.button.url" :target="slide.intro_button.button.target">{{ slide.intro_button.button.title }}</btn>
                        <div class="intro-slider__dots" v-if="intro_.slides.length > 1" data-glide-el="controls[nav]">
                            <button v-for="n in intro_.slides.length" :key="n" class="glide__bullet" :data-glide-dir="`=${n-1}`"></button>
                        </div>
                    </template>
                </block-intro>
            </div>
        </div>
    </block>
</template>

<script>
import Glide, { Controls, Swipe } from '@glidejs/glide/dist/glide.modular.esm'
import defaultsDeep from "lodash-es/defaultsDeep";

export default {
    props: {
        intro: {
            type: Object
        }
    },

    data() {
        return {
            intro_: defaultsDeep(this.intro, {
                transparent: false,
                slides: []
            }),
            slider: null
        }
    },

    mounted() {
        if (this.intro_.transparent) {
            document.querySelector('body').classList.add('header-transparent');
            document.querySelector('body').classList.add(`header-transparent--${this.intro_.scheme == 'dark' ? 'white' : 'dark'}`);
        }

        if (this.intro_.slides.length > 1) {
            this.slider = new Glide(this.$el, {
                gap: 0
            }).mount({ Controls, Swipe });
        }
    }
}
</script>